// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "VNAnimateEvent.hpp"

namespace Dawn {
  template<typename T>
  class VNSetEvent : public VNAnimateEvent<T> {
    public:
      T *modifies = nullptr;

    protected:
      void onStart() override {
        assertNotNull(this->modifies);
        this->from = *modifies;
        
        VNAnimateEvent<T>::onStart();
      }

      void setValue(T value) override {
        *modifies = value;
      }
  };
}