// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "UIShader.hpp"
#include "util/macro.hpp"

#define FONT_SHADER_PARTS_MAX 6
#define FONT_SHADER_QUADS_MAX 64
#define FONT_SHADER_TEXTURE_MAX 8

namespace Dawn {
  struct FontShaderPart {
    struct Color color;
    int32_t texture;
  };

  struct FontShaderBufferData {
    struct FontShaderPart fontParts[FONT_SHADER_PARTS_MAX];
    int32_t fontQuadParts[FONT_SHADER_QUADS_MAX];
  };

  class FontShaderBuffer : public ShaderParameterBuffer<struct FontShaderBufferData> {

  };

  class FontShader : public Shader {
    public:
      shaderparameter_t paramModel;
      shaderparameter_t paramTexture0;
      shaderparameter_t paramTexture1;
      shaderbufferlocation_t bufferUiCanvas;
      shaderbufferlocation_t bufferFont;

      void compile() override;
  };
}